// RedJey Graphics User Interface Library for J2ME Platform.
// Copyright (C) 2008 Yevgen Krapiva
//
// This library is free software; you can redistribute
// it and/or modify it under the terms of the
// GNU Lesser General Public License as published
// by the Free Software Foundation; either version 3.0
// of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

package com.incrediblesoft.redjey;

/**
 * @author Yevgen Krapiva<br>
 *         Homepage: http://code.google.com/p/redjey/<br>
 *         Feedback: ykrapiva@gmail.com<br>
 *         Copyright (C) 2008 Yevgen Krapiva<br>
 */

import javax.microedition.lcdui.Graphics;
import java.util.Hashtable;

public class ImageItem extends Component
{
    private CustomImage image;

    public ImageItem(CustomImage image)
    {
        super();
        setImage(image);
    }

    public String getName()
    {
        return "ImageItem";
    }

    protected boolean isLightweight()
    {
        return true;
    }

    public void setImage(CustomImage image)
    {
        this.image = image;
        invalidate();
        if (image != null)
            image.parent = this;
    }

    protected Dimension calcPreferredSize(int paddingHorizontal, int paddingVertical, CustomFont font, Hashtable attributes)
    {
        int w = 0;
        int h = 0;
        if (image != null)
        {
            w += image.getWidth();
            h += image.getHeight();
        }
        return new Dimension(w, h);
    }

    public boolean isFocusable()
    {
        return false;
    }

    protected void validateComponent()
    {
        
    }

    public void tick(int dt)
    {
        super.tick(dt);

        if (image != null)
            image.tick(dt);
    }

    protected void paintComponent(Graphics g)
    {
        if (image != null)
            image.paint(g, 0, 0, Graphics.LEFT | Graphics.TOP);
    }
}
