// RedJey Graphics User Interface Library for J2ME Platform.
// Copyright (C) 2008 Yevgen Krapiva
//
// This library is free software; you can redistribute
// it and/or modify it under the terms of the
// GNU Lesser General Public License as published
// by the Free Software Foundation; either version 3.0
// of the License, or any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

package com.incrediblesoft.redjey.backgrounds;

/**
 * @author Yevgen Krapiva<br>
 *         Homepage: http://code.google.com/p/redjey/<br>
 *         Feedback: ykrapiva@gmail.com<br>
 *         Copyright (C) 2008 Yevgen Krapiva<br>
 */

import javax.microedition.lcdui.Graphics;
import java.util.Hashtable;


public abstract class Background
{
    /**
     * Defines the width and height of this Background.
     */
    public int borderWidth;
    public int borderHeight;

    /**
     * Creates a new Background.
     */
    public Background()
    {
        this.borderWidth = 0;
        this.borderHeight = 0;
    }

    public Background(Hashtable styleDesc)
    {
        this();
        
        String borderWidthStr = (String) styleDesc.get("width");
        String borderHeightStr = (String) styleDesc.get("height");
        if (borderWidthStr != null) borderWidth = Integer.parseInt(borderWidthStr);
        if (borderHeightStr != null) borderHeight = Integer.parseInt(borderHeightStr);
    }

    public void tick(int dt)
    {

    }

    /**
     * Paints this background.
     *
     * @param x the horizontal start point
     * @param y the vertical start point
     * @param width the width of the background
     * @param height the height of the background
     * @param g the Graphics on which the background should be painted.
     */

    public abstract void paint(Graphics g, int x, int y, int width, int height);

    public abstract Background clone();
}
